VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "myDoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Public Event BreakLine(Data$, datanext$)
Public Event Lastline()

Dim mPosId As Long
Dim mCurrentParagraph As Long
' each paragraph has a number
Private Type Paragraph
  content() As String
lines As Long  ' computed by the width of ruler...
End Type
Public LfLead As Boolean
Public CrTail As Boolean

Dim DocParaBack() As Long, DocParaNext() As Long, para() As Paragraph
Dim neopara As Long, paramax As Long, docmax As Long, docpara As Long
Dim delDocPara As Long
Public MarkParagraphID As Long  ' this is the direct paranum non indirect
Dim mKeystart As String
Function IsLast(ByVal paranum As Long) As Boolean
' for MarkParagraphID
IsLast = (DocParaNext(paranum) = 0)
End Function
Function IsEmpty() As Boolean
If DocParaNext(0) = 0 And DocParaBack(0) = 0 Then IsEmpty = True
End Function
Function FindNewPara() As Long
If delDocPara > 0 Then
FindNewPara = delDocPara
delDocPara = DocParaNext(delDocPara)
Else
docpara = docpara + 1
If docpara > docmax Then
docmax = docmax * 2
ReDim Preserve DocParaBack(0 To docmax)
ReDim Preserve DocParaNext(0 To docmax)
ReDim Preserve para(1 To docmax)
End If
FindNewPara = docpara
End If
End Function
Sub InsertDocPara(ByVal paranum As Long, ByVal Previus As Long, ByVal NextPara As Long)
    DocParaNext(paranum) = NextPara
    DocParaBack(paranum) = Previus
    DocParaNext(Previus) = paranum
    DocParaBack(NextPara) = paranum
End Sub
Sub UnlinkDocPara(paranum As Long)
   DocParaNext(DocParaBack(paranum)) = DocParaNext(paranum)
    DocParaBack(DocParaNext(paranum)) = DocParaBack(paranum)
End Sub
Sub LinkDocParaAfter(paranum As Long, thisparanum As Long)
    DocParaBack(DocParaNext(thisparanum)) = paranum
    DocParaNext(paranum) = DocParaNext(thisparanum)
    DocParaBack(paranum) = thisparanum
    DocParaNext(thisparanum) = paranum
End Sub

Sub RemoveDocParaIndex(paranum As Long)
    DocParaNext(DocParaBack(paranum)) = DocParaNext(paranum)
    DocParaBack(DocParaNext(paranum)) = DocParaBack(paranum)
    para(paranum).lines = 0   ' clear' also can be a flag to show that this is deleted
    ReDim para(paranum).content(1 To 1)
    DocParaNext(paranum) = delDocPara
    delDocPara = paranum
End Sub
Sub WritePara(paranum As Long, ByVal Data$)
    Dim neodata$, neolines As Long, thatmax As Long
    Do
    neolines = para(paranum).lines + 1
    If neolines = 1 Then
    thatmax = 10
    ReDim Preserve para(paranum).content(1 To thatmax)
    End If
    thatmax = UBound(para(paranum).content())
    If thatmax < neolines Then
    thatmax = thatmax * 2
    ReDim Preserve para(paranum).content(1 To thatmax)
    End If
    RaiseEvent BreakLine(Data$, neodata$)  ' no method inside this class
    If neodata$ = "" Then neodata$ = Data$: Data$ = ""
    para(paranum).content(neolines) = neodata$
    para(paranum).lines = neolines
    neodata$ = ""
    Loop Until Data$ = ""
End Sub

Sub ReWritePara(paranum As Long, ByVal Data$)
    Dim neodata$, neolines As Long, thatmax As Long
    If paranum = 0 Then Exit Sub
    para(paranum).lines = 0  ' clear
    ReDim para(paranum).content(1 To 1)
    Do
    neolines = para(paranum).lines + 1
    If neolines = 1 Then
    thatmax = 10
    ReDim Preserve para(paranum).content(1 To thatmax)
    End If
    thatmax = UBound(para(paranum).content())
    If thatmax < neolines Then
    thatmax = thatmax * 2
    ReDim Preserve para(paranum).content(1 To thatmax)
    End If
    RaiseEvent BreakLine(Data$, neodata$)  ' no method inside this class
    If neodata$ = "" Then neodata$ = Data$: Data$ = ""
    para(paranum).content(neolines) = neodata$
    para(paranum).lines = neolines
    neodata$ = ""
    Loop Until Data$ = ""
End Sub
Function AppendParagraph(myparagraph$) As Long
    Dim getAparaNum As Long
    getAparaNum = FindNewPara
    WritePara getAparaNum, myparagraph$
    ' getAparaNum is paragraph absolute address
    If docpara = 0 Then
        InsertDocPara getAparaNum, 0, 0  ' back is 0 and next is zero.
    Else
        InsertDocPara getAparaNum, DocParaBack(0), 0  ' DocParaBack(0) link to last
    End If
    AppendParagraph = getAparaNum
End Function
Function InsertAfterParagraph(paranum As Long, myparagraph$) As Long
    Dim getAparaNum As Long
    getAparaNum = FindNewPara
    WritePara getAparaNum, myparagraph$
    If paranum = -1 Then
     If docpara = 0 Then
        InsertDocPara getAparaNum, 0, 0  ' back is 0 and next is zero.
    Else
        InsertDocPara getAparaNum, DocParaBack(0), 0  ' DocParaBack(0) link to last
    End If
    Else
    InsertDocPara getAparaNum, paranum, DocParaNext(paranum)
    End If
    InsertAfterParagraph = getAparaNum
End Function
Function InsertBeforeParagraph(paranum As Long, myparagraph$) As Long
    Dim getAparaNum As Long
    getAparaNum = FindNewPara
    WritePara getAparaNum, myparagraph$
    InsertDocPara getAparaNum, DocParaBack(paranum), paranum
    InsertBeforeParagraph = getAparaNum
End Function
Property Let textDoc(norawtext As String)
    Dim where As Long ', before As Long, t_text As String
    Dim a() As String
    where = 1
    a() = Split(norawtext, vbCrLf)
        norawtext = Join(a(), vbLf)
        If InStr(norawtext, vbLf) = 0 Then
        AppendParagraph norawtext
        Else
      a() = Split(norawtext, vbLf)
      For where = LBound(a()) To UBound(a())
      AppendParagraph a(where)
      Next where
    End If
End Property
Public Function textFormat(ByVal linebreak2use$) As String
'
 Dim mycur As Long, b As Boolean
mycur = DocParaNext(0)
b = False
Do While mycur <> 0
If b Then
textFormat = textDoc + linebreak2use$ + TextParagraph(mycur)
Else
b = True
textFormat = TextParagraph(mycur)
End If
mycur = DocParaNext(mycur)
Loop
End Function
Property Get textDoc() As String
Attribute textDoc.VB_UserMemId = 0
'
 Dim mycur As Long, b As Boolean
mycur = DocParaNext(0)
b = False
Do While mycur <> 0
If b Then
textDoc = textDoc + vbCrLf + TextParagraph(mycur)
Else
b = True
textDoc = TextParagraph(mycur)
End If
mycur = DocParaNext(mycur)
Loop
End Property


Public Sub InsertDoc(ByVal paranum As Long, fromPos As Long, norawtext As String)
    Dim t_text As String, ONCE As Boolean
    Dim a() As String
    Dim b$
    ONCE = True
      a() = Split(norawtext, vbCrLf)
        norawtext = Join(a(), vbLf)
     a() = Split(norawtext + vbLf, vbLf)
Dim i As Long
    i = LBound(a())
    Do

    t_text = a(i)
    i = i + 1
    If t_text = "" And i > UBound(a()) Then
    If b$ <> "" Then
        ReWritePara paranum, TextParagraph(paranum) + b$
        b$ = ""
    End If
    Exit Do
    End If
    If ONCE Then
    ONCE = False
        b$ = TextParagraph(paranum)
        If fromPos = 1 Then
          ReWritePara paranum, t_text
          fromPos = Len(t_text) + 1
       
        ElseIf fromPos > Len(b$) Then
           
           ReWritePara paranum, b$ & t_text
            fromPos = Len(b$ & t_text) + 1
            
            b$ = ""
        Else
        If fromPos = 0 Then fromPos = 1
        ReWritePara paranum, Left$(b$, fromPos - 1) + t_text
        b$ = Mid$(b$, fromPos)
        fromPos = fromPos + Len(t_text)
        
        End If
    Else
    paranum = InsertAfterParagraph(paranum, t_text)
         fromPos = Len(t_text) + 1
       
    End If
    Loop
    MarkParagraphID = paranum
   
End Sub
Property Get DocLines() As Long
    Dim mycur As Long, mlines As Long
    mycur = DocParaNext(0)
    While mycur <> 0
        mlines = para(mycur).lines + mlines
        mycur = DocParaNext(mycur)
    Wend
    DocLines = mlines
End Property
Property Get DocParagraphs() As Long
    Dim mycur As Long, dPara As Long
    mycur = DocParaNext(0)
    While mycur <> 0
        dPara = dPara + 1
        mycur = DocParaNext(mycur)
    Wend
    DocParagraphs = dPara
End Property

Property Get FirstParagraphLine(paranum As Long) As Long
    Dim mycur As Long, mlines As Long, mlinesold As Long, valid As Boolean
    mlinesold = 0
    mycur = DocParaNext(0)
    Do While mycur <> 0
        mlinesold = mlines
        If mycur = paranum Then valid = True: Exit Do
        mlines = para(mycur).lines + mlines
        mycur = DocParaNext(mycur)
    Loop
    If valid Then FirstParagraphLine = mlinesold
End Property

'
Public Sub FindPos(ByVal fromLineNo As Long, ByVal fromPos As Long, CharNumber As Long, toLineNo As Long, toPos As Long, toParagraph As Long, toParaPos As Long)
Dim probelen As Long, i As Long, target As Long, sum As Long
Dim mycur As Long, mlines As Long, mlinesold As Long, sumtohere As Long
toLineNo = fromLineNo
toPos = fromPos
toParagraph = DocParaNext(0)
toParaPos = 1
If fromLineNo < 1 Then Exit Sub
    mlinesold = 0
    mycur = DocParaNext(0)
    Do While mycur <> 0
        mlinesold = mlines
        mlines = para(mycur).lines + mlines
        If fromLineNo <= mlines Then Exit Do
         sumtohere = sumtohere + TextParagraphLen(mycur)
        mycur = DocParaNext(mycur)
        If Not mycur = 0 Then sumtohere = sumtohere + 2         ' now we put the vbcrlf length (these are not bytes)
    Loop
    toParagraph = mycur
    If CharNumber = 0 Then Exit Sub
    If mycur <> 0 Then
        target = fromLineNo - mlinesold
        probelen = 0
        For i = 1 To target - 1
             toPos = Len(para(mycur).content(i))
             probelen = probelen + toPos
             sumtohere = sumtohere + toPos
        Next i
        toLineNo = fromLineNo
        toPos = Len(para(mycur).content(target))
        If CharNumber < 0 Then
            If fromPos = 0 Then
                CharNumber = sumtohere
            Else
                CharNumber = sumtohere + fromPos - 1
            End If
            Exit Sub
        Else
           sum = toPos - fromPos
        End If
        If target = para(mycur).lines Then
           
                        If (CharNumber - sum) <= 2 Then
                            If (CharNumber - sum) = 2 Then
                                 If DocParaNext(mycur) = 0 Then
                              toPos = CharNumber + fromPos
                              toParaPos = toPos + probelen - 2
                              
                              Else
                                toPos = 0
                                toParagraph = DocParaNext(mycur)
                                toLineNo = toLineNo + 1
                                toParaPos = 0
                                End If
                            Else
                                toPos = CharNumber + fromPos
                                toParaPos = toPos + probelen
                            End If
                            Exit Sub
                        End If
               
        Else
                If CharNumber <= sum Then
                    toPos = CharNumber + fromPos
                    toParaPos = toPos + probelen
                    Exit Sub
                End If
        End If
        sum = toPos - fromPos
        probelen = probelen + toPos
        Do
                For i = target + 1 To para(mycur).lines - 1
                    toLineNo = i + mlinesold  ' set the right lineNo
                    toPos = Len(para(mycur).content(i))
                    probelen = probelen + toPos
                    sum = sum + toPos
                    If sum >= CharNumber Then
                        probelen = probelen - toPos  ' rewind
                        toParaPos = probelen + CharNumber - (sum - toPos)
                        toPos = CharNumber - (sum - toPos)
                        Exit Sub
                    End If
                Next i
                toPos = Len(para(mycur).content(i))
                toLineNo = i + mlinesold
                If DocParaNext(mycur) = 0 Then
                        If (CharNumber - sum) <= toPos Then
                            toPos = CharNumber - sum - 1
                        End If
                        toParaPos = toPos + probelen
                        Exit Do
                Else
                        If (CharNumber - sum - toPos) <= 2 Then
                               If (CharNumber - sum - toPos) = 2 Then
                                    toPos = 0
                                    toParagraph = DocParaNext(mycur)
                                    toLineNo = toLineNo + 1
                                    toParaPos = 0
                                Else
                                    toPos = CharNumber - sum
                                    toParaPos = toPos + probelen
                                End If
                                Exit Sub
                        End If
                End If
                probelen = 0
                sum = sum + toPos + 2
                mycur = DocParaNext(mycur)
                toParagraph = mycur
                target = 0
                mlinesold = mlines
                mlines = para(mycur).lines + mlines
        Loop
    End If
    toParaPos = toParaPos + 1
    toPos = toPos + 1
End Sub
Public Function RemoveEmptyParagraph(paranum As Long) As Boolean
' but not last, only erased
Dim oldone As Long
If TextParagraphLen(paranum) = 0 Then
RemoveEmptyParagraph = True
oldone = DocParaNext(paranum)
If oldone = 0 Then oldone = DocParaBack(paranum)
If oldone = 0 Then
    para(paranum).lines = 1  ' clear
    ReDim para(paranum).content(1 To 1)
Else
RemoveDocParaIndex paranum
paranum = oldone
End If
End If
End Function


Property Get TextLine(lineno As Long) As String
If lineno < 1 Then Exit Property
    Dim mycur As Long, mlines As Long, mlinesold As Long
    mlinesold = 0
    mycur = DocParaNext(0)
    Do While mycur <> 0
        mlinesold = mlines
        mlines = para(mycur).lines + mlines
        If lineno <= mlines Then Exit Do
        mycur = DocParaNext(mycur)
    Loop
    If lineno <= mlines Then
        TextLine = para(mycur).content(lineno - mlinesold)
    End If
End Property
Property Let TextLine(lineno As Long, that As String)
    Dim mycur As Long, mlines As Long, mlinesold As Long
    mlinesold = 0
    mycur = DocParaNext(0)
    Do While mycur <> 0
        mlinesold = mlines
        mlines = para(mycur).lines + mlines
        If lineno <= mlines Then Exit Do
        mycur = DocParaNext(mycur)
    Loop
    If lineno <= mlines Then
        para(mycur).content(lineno - mlinesold) = that
    End If
End Property
Property Get ParagraphFromOrder(ByVal order As Long) As Long
    ParagraphFromOrder = -1
    Dim mycur As Long
    mycur = DocParaNext(0)
    Do While mycur > 0
        order = order - 1
        If order = 0 Then ParagraphFromOrder = mycur: Exit Do
        mycur = DocParaNext(mycur)
    Loop
End Property
Property Get ParagraphOrder(paranum As Long) As Long
    ParagraphOrder = 0
    Dim mycur As Long, order As Long
    mycur = DocParaNext(0)
    Do While mycur > 0
        order = order + 1
        If mycur = paranum Then ParagraphOrder = order: Exit Do
        mycur = DocParaNext(mycur)
    Loop
End Property
Property Get LastParagraph() As Long
LastParagraph = DocParaBack(0)
End Property
Property Get SizeCRLF() As Long
Dim mycur As Long, suma As Long, K As Long
If IsEmpty Then
Else
 mycur = DocParaNext(0)
  K = -1
    Do While mycur > 0
    K = K + 1
        suma = suma + TextParagraphLen(mycur)
        mycur = DocParaNext(mycur)
    Loop
    End If
    SizeCRLF = suma + K * 2
End Property
Property Get TextParagraphOrder(ByVal order As Long) As String
    ' 1 is the first
    ' -1 is the last
    Dim mycur As Long
    If order = -1 Then
        mycur = DocParaBack(0)
        TextParagraphOrder = TextParagraph(mycur)
        Exit Property
    ElseIf order = 0 Then
        order = 1
    End If
    mycur = DocParaNext(0)
    Do While mycur > 0
        order = order - 1
        If order = 0 Then
            TextParagraphOrder = TextParagraph(mycur)
            Exit Property
        End If
        mycur = DocParaNext(mycur)
    Loop
End Property
Property Get TextParagraphOrderRemove(ByVal order As Long) As String
    ' 1 is the first
    ' -1 is the last
    Dim mycur As Long
    If order = -1 Then
        mycur = DocParaBack(0)
        TextParagraphOrderRemove = TextParagraph(mycur)
         RemoveDocParaIndex mycur
        Exit Property
    ElseIf order = 0 Then
        order = 1
    End If
    mycur = DocParaNext(0)
    Do While mycur > 0
        order = order - 1
        If order = 0 Then
            TextParagraphOrderRemove = TextParagraph(mycur)
            RemoveDocParaIndex mycur
            Exit Property
        End If
        mycur = DocParaNext(mycur)
    Loop
End Property
Public Function FindStr(s$, ByVal st&, FindParaOrder As Long, FindPosPara As Long) As Long
Dim mycur As Long, ac&, ac1&, acp&, mlines As Long, wh&, order As Long
mycur = DocParaNext(0)
order = -1
    Do While mycur > 0
 order = order + 1
    ac& = acp&
    If st& <= 0 Then st& = 1
    For mlines = 1 To para(mycur).lines
        ac1& = ac& + Len(para(mycur).content(mlines))
        If ac1& > st& Then
        If st& - ac& <= 0 Then st& = ac& + 1
        wh& = InStr(st& - ac&, para(mycur).content(mlines), s$)
        If wh& > 0 Then
            FindParaOrder = order + 1
            FindPosPara = wh& + ac& - acp&
            FindStr = wh& + ac&
        Exit Function
        End If
        Exit Do
        
        End If
    Next mlines
      acp& = ac1& + 2  'for linefeed
      mycur = DocParaNext(mycur)
      
    Loop
    If mycur > 0 Then
        If mlines < para(mycur).lines Then
            For mlines = mlines To para(mycur).lines
            ac1& = ac& + Len(para(mycur).content(mlines))
            wh& = InStr(para(mycur).content(mlines), s$)
                If wh& > 0 Then
                        FindParaOrder = order
                        FindPosPara = wh& + ac& - acp&
                        FindStr = wh& + ac&
                        Exit Function
                End If
        Next mlines
          acp& = ac1& + 2   'for linefeed
          mycur = DocParaNext(mycur)
        End If
    End If
        Do While mycur > 0
        order = order + 1
        ac& = acp&
    For mlines = 1 To para(mycur).lines
        ac1& = ac& + Len(para(mycur).content(mlines))
        wh& = InStr(para(mycur).content(mlines), s$)
        If wh& > 0 Then
                 FindParaOrder = order
                 FindPosPara = wh& + ac& - acp&
                 FindStr = wh& + ac&
                 Exit Function
                 Exit Do
         End If
     Next mlines
      acp& = ac1& + 2  'for linefeed
      mycur = DocParaNext(mycur)
    Loop
    

    
End Function
Property Let TextParagraphOrder(ByVal order As Long, Data$)
    Dim mycur As Long
    If order = -1 Then
        mycur = DocParaBack(0)
        ReWritePara mycur, Data$
        Exit Property
    ElseIf order = 0 Then
        order = 1
    End If
    mycur = DocParaNext(0)
    Do While mycur > 0
        order = order - 1
        If order = 0 Then
            ReWritePara mycur, Data$
            Exit Property
        End If
        mycur = DocParaNext(mycur)
    Loop
End Property
Property Get TextParagraph(ByVal paranum As Long) As String
    Dim mlines As Long, neodata As String
    If paranum = 0 Then TextParagraph = "": Exit Property
    For mlines = 1 To para(paranum).lines
        neodata = neodata + para(paranum).content(mlines)
    Next mlines
    TextParagraph = neodata
End Property
Property Get TextParagraphKey(ByVal paranum As Long) As String
    Dim mlines As Long, neodata As String
    If paranum = 0 Then TextParagraphKey = "": Exit Property
    For mlines = 1 To para(paranum).lines
        neodata = neodata + para(paranum).content(mlines)
    Next mlines
    TextParagraphKey = Mid$(neodata, mKeystart)
End Property

Property Let TextParagraph(ByVal paranum As Long, Data$)
    If paranum = 0 Then Exit Property
    para(paranum).lines = 1   ' clear' also can be a flag to show that this is deleted
    ReDim para(paranum).content(1 To 1)
    para(paranum).content(1) = Data$
End Property

Property Get TextParagraphLen(ByVal paranum As Long) As Long
' without addition of 2 chars vbcrlf
    Dim mlines As Long, neodatalen As Long
    If paranum = 0 Then TextParagraphLen = "": Exit Property
    For mlines = 1 To para(paranum).lines
        neodatalen = neodatalen + Len(para(paranum).content(mlines))
    Next mlines
    TextParagraphLen = neodatalen
End Property
Function TextNextParagraph(paranum As Long) As String
Dim mycur As Long
mycur = DocParaNext(paranum)
If mycur > 0 Then
TextNextParagraph = TextParagraph(mycur)
paranum = mycur
End If

End Function
Function DeleteNextParagraph(ByVal paranum As Long) As String
    Dim mynextcur As Long
    mynextcur = DocParaNext(paranum)
    If mynextcur <> 0 Then
        DeleteNextParagraph = TextParagraph(mynextcur)
        RemoveDocParaIndex mynextcur
    End If
End Function
Function DeletePreviusParagraph(ByVal paranum As Long) As String
    Dim mybackcur As Long
    mybackcur = DocParaBack(paranum)
    If mybackcur <> 0 Then
        DeletePreviusParagraph = TextParagraph(mybackcur)
        RemoveDocParaIndex mybackcur
    End If
End Function

Property Get TextParagraph2Line(ByVal paranum As Long, ByVal Charpos As Long, newselstart) As Long
Dim mlines As Long, counter As Long
    If paranum = 0 Then Exit Property
     For mlines = 1 To para(paranum).lines
        counter = counter + Len(para(paranum).content(mlines))
        If Charpos <= counter Then
            newselstart = Charpos - (counter - Len(para(paranum).content(mlines))) '  - 1 to write from right to left
            TextParagraph2Line = mlines - 1
            Exit Property
        End If
    Next mlines
    If Charpos > counter Then newselstart = Len(para(paranum).content(para(paranum).lines)) + 1
    TextParagraph2Line = mlines - 2
End Property

Function TextParagraphLine(ByVal lineno As Long, thistext As String, paranum As Long) As Long
    ' for lineno get line and paragraph id..
    ' we want to mark the current paragraph
    Dim mycur As Long, mlines As Long, mlinesold As Long, i As Long
    mlinesold = 0
    mycur = DocParaNext(0)
    Do While mycur <> 0
        mlinesold = mlines
        mlines = para(mycur).lines + mlines
        If lineno <= mlines Then Exit Do
        mycur = DocParaNext(mycur)
    Loop
    If lineno <= mlines Then
    If lineno = mlines Then RaiseEvent Lastline
      If (lineno - mlinesold) > 0 Then thistext = para(mycur).content(lineno - mlinesold)
        paranum = mycur
        If (lineno - mlinesold) = 1 Then
            TextParagraphLine = 0
        Else
            For i = 1 To lineno - mlinesold - 1
                TextParagraphLine = TextParagraphLine + Len(para(mycur).content(i))
            Next i
        End If
        
    Else
        thistext = ""
        paranum = 0
    End If
End Function

Sub GoTopLinePreviusParagraph(lineno As Long, thistext As String, paranum As Long)
' we give Paranum and we get lineno and thistext as first line, and new paranum
    Dim mycur As Long, mlines As Long, mlinesold As Long
    mlinesold = 0
    mycur = DocParaNext(0)
    If mycur > 0 Then
        If mycur = paranum Then
            thistext = para(paranum).content(1)  ' first line
            lineno = 1
            Exit Sub
        End If
    End If
    Do While mycur <> 0
        mlinesold = mlines
        If DocParaNext(mycur) = paranum Then Exit Do
        mlines = para(mycur).lines + mlines
        mycur = DocParaNext(mycur)
    Loop
    If DocParaNext(mycur) = paranum Then
        paranum = mycur
        thistext = para(paranum).content(1)  ' first line
        lineno = mlinesold + 1
    Else
        paranum = DocParaNext(0): mlinesold = 0
        thistext = para(paranum).content(1)  ' first line
        lineno = mlinesold + 1
    End If
End Sub
Sub GoTopLineNextParagraph(lineno As Long, thistext As String, paranum As Long)
' we give Paranum and we get lineno and thistext as first line at the next Paranum..
    Dim mycur As Long, mlines As Long, mlinesold As Long
    mlinesold = 0
    mycur = DocParaNext(0)
    Do While mycur <> 0
        mlinesold = mlines
        If mycur = paranum Then Exit Do  'lineno=mlinesold+1
        mlines = para(mycur).lines + mlines
        mycur = DocParaNext(mycur)
    Loop
    If mycur = paranum Then
        If DocParaNext(mycur) <> 0 Then
            mlines = para(mycur).lines + mlines
            mycur = DocParaNext(mycur)
        End If
        paranum = mycur ' new paragraph id
        thistext = para(paranum).content(1)  ' first line
        lineno = mlinesold + 1
    Else
        mycur = DocParaNext(0): mlinesold = 0  ' go to start again if not found..
        paranum = mycur ' new paragraph id
        thistext = para(paranum).content(1)  ' first line
        lineno = mlinesold + 1
    End If
End Sub
Sub WrapAgain()
Dim mycur As Long
mycur = DocParaNext(0)
Do While mycur <> 0
 ReWritePara mycur, TextParagraph(mycur)
mycur = DocParaNext(mycur)
Loop

End Sub

Private Sub Class_Initialize()
' from this version paramax= docmax
'paramax = 20 ' 20 parapraphs ...content
docmax = 20  ' 20 paragraphs..links only
ReDim para(1 To docmax)
ReDim DocParaBack(0 To docmax)
ReDim DocParaNext(0 To docmax)
End Sub

Sub BackSpaceNchars(fromPARA As Long, fromPos As Long, ByVal Nchars As Long)
' we return the current frompara and from pos
Dim ww As Long, ThatPara
ww = TextParagraphLen(fromPARA)
'If fromPos > ww Then Nchars = Nchars - (fromPos - ww): fromPos = ww

Do While Nchars > 0
If fromPos = 0 Then
fromPARA = DocParaBack(fromPARA)
fromPos = TextParagraphLen(fromPARA) + 1
TextParagraph(fromPARA) = TextParagraph(fromPARA) + Chr$(10) + DeleteNextParagraph(fromPARA)
Nchars = Nchars - 1
ElseIf fromPos = 1 Then
If Nchars > 2 Then
Nchars = Nchars - 2
fromPARA = DocParaBack(fromPARA)
fromPos = TextParagraphLen(fromPARA) + 1
TextParagraph(fromPARA) = TextParagraph(fromPARA) + DeleteNextParagraph(fromPARA)

' CONTINUE
Else
Nchars = Nchars - 1
fromPARA = DocParaBack(fromPARA)
fromPos = TextParagraphLen(fromPARA) + 2
TextParagraph(fromPARA) = TextParagraph(fromPARA) + Chr$(13) + DeleteNextParagraph(fromPARA)
End If
ElseIf fromPos > Nchars Then

TextParagraph(fromPARA) = Left(TextParagraph(fromPARA), fromPos - Nchars - 1) + Mid$(TextParagraph(fromPARA), fromPos)
fromPos = fromPos - Nchars
Exit Do
Else
Nchars = Nchars - fromPos + 1
      ThatPara = DocParaBack(fromPARA)
      
        If fromPos = TextParagraphLen(fromPARA) Then
        RemoveDocParaIndex fromPARA
        
        Else
        TextParagraph(fromPARA) = Mid$(TextParagraph(fromPARA), fromPos)
        End If
        
        If ThatPara = 0 Then ThatPara = DocParaNext(0)
        fromPARA = ThatPara
        If fromPARA = 0 Then
        ' make only one empty paragraph
        Stop
        Exit Sub
        End If
      fromPos = TextParagraphLen(fromPARA) + 1
      If Nchars >= 2 Then
      Nchars = Nchars - 2
      
      TextParagraph(fromPARA) = TextParagraph(fromPARA) + DeleteNextParagraph(fromPARA)
      ElseIf Nchars = 1 Then
      TextParagraph(fromPARA) = TextParagraph(fromPARA) + Chr$(13) + DeleteNextParagraph(fromPARA)
      fromPos = fromPos + 1
      Nchars = 0
      Else
      
      Exit Sub
      End If
     
    
    
End If

Loop


End Sub

Sub SortDoc1(KeyStart As Long, order1 As Long, order2 As Long)
Dim i As Long, Ind() As Long, Arr() As String
  ReDim Ind(DocParagraphs)
  ReDim Arr(LBound(para) To UBound(para))
  mKeystart = IIf(KeyStart < 0, 1, KeyStart)
 
  For i = 1 To UBound(Ind)
    Ind(i) = DocParaNext(Ind(i - 1))
    Arr(i) = TextParagraphKey(Ind(i))
  Next i
  If order1 <= 0 Then order1 = 1
  If order2 <= 0 Then order2 = i - 1

  DualPivotQuickSort Arr, Ind, order1, order2
  
  For i = 1 To UBound(Ind)
    DocParaNext(Ind(i - 1)) = Ind(i)
    DocParaBack(Ind(i)) = Ind(i - 1)
  Next i
  DocParaNext(Ind(UBound(Ind))) = 0
  DocParaBack(0) = Ind(UBound(Ind))
End Sub

Sub SortDoc(KeyStart As Long, order1 As Long, order2 As Long)
Dim i As Long, Ind() As Long, Arr() As String
  ReDim Ind(DocParagraphs)
  ReDim Arr(LBound(para) To UBound(para))
  mKeystart = IIf(KeyStart < 0, 1, KeyStart)
 
  For i = 1 To UBound(Ind)
    Ind(i) = DocParaNext(Ind(i - 1))
    Arr(i) = TextParagraphKey(Ind(i))
  Next i
  If order1 <= 0 Then order1 = 1
  If order2 <= 0 Then order2 = i - 1

  QuickSortExtended Arr, Ind, order1, order2
  
  For i = 1 To UBound(Ind)
    DocParaNext(Ind(i - 1)) = Ind(i)
    DocParaBack(Ind(i)) = Ind(i - 1)
  Next i
  DocParaNext(Ind(UBound(Ind))) = 0
  DocParaBack(0) = Ind(UBound(Ind))
End Sub

Public Function Advance(cursor As Long) As Long
cursor = DocParaNext(cursor)
Advance = cursor
End Function
Public Function BackStep(cursor As Long) As Long
cursor = DocParaBack(cursor)
BackStep = cursor
End Function
 
