Attribute VB_Name = "modHeapSort"
Option Explicit
'
'HeapsortLongs (adapted from Code by dilettante)
'==============
 
Private Sub Heapify(Longs() As Long, ByVal Count As Long)
Dim Start As Long
    
    For Start = Count \ 2 - 1 To 0 Step -1
        SiftDown Longs, Start, Count - 1
    Next
End Sub

Private Sub SiftDown(Longs() As Long, ByVal Start As Long, ByVal Last As Long)
Dim Root As Long, Child As Long, Swap As Long, TempValue As Long
    
    Root = Start
    Do While Root * 2 + 1 <= Last
        Child = Root * 2 + 1
        Swap = Root
        If Longs(Swap) < Longs(Child) Then Swap = Child
 
        If Child + 1 <= Last Then
            If Longs(Swap) < Longs(Child + 1) Then Swap = Child + 1
        End If
        
        If Swap = Root Then Exit Do
        TempValue = Longs(Root)
        Longs(Root) = Longs(Swap)
        Longs(Swap) = TempValue
        Root = Swap
    Loop
End Sub

Public Sub HeapSortLongs(Longs() As Long)
Dim Last As Long, TempValue As Long
    
    Heapify Longs, UBound(Longs) + 1
    For Last = UBound(Longs) To 1 Step -1
        TempValue = Longs(Last)
        Longs(Last) = Longs(0)
        Longs(0) = TempValue
        SiftDown Longs, 0, Last - 1
    Next
End Sub
